/* painterclass.h */

#ifndef Y_BUFFER_PAINTERCLASS_H
#define Y_BUFFER_PAINTERCLASS_H

struct PainterClass;

#include <Y/y.h>
#include <Y/buffer/painter.h>
#include <Y/util/colour.h>

struct Painter *painterCreate ();

struct PainterState
{
  void *d;
  enum ColourBlendMode blendMode;
  uint32_t penColour, fillColour;
  double scaleX, scaleY, translateX, translateY;
  int clipping;
  struct Rectangle clipRectangle;

  struct PainterState *previous;
};

struct Painter
{
  struct PainterClass *c;
  void *d;
  struct PainterState *state;
};

struct PainterClass
{
  char *name;
  void (*clearRectangle) (struct Painter *, int x, int y, int w, int h);
  void (*drawRectangle)  (struct Painter *, int x, int y, int w, int h);
  void (*drawHLine)      (struct Painter *, int x, int y, int dx);
  void (*drawVLine)      (struct Painter *, int x, int y, int dy);
  void (*drawLine)       (struct Painter *, int x, int y, int dx, int dy);
  void (*drawAlphamap)   (struct Painter *, unsigned char *alpha,
                          int x, int y, int w, int h, int s);
  void (*drawRGBAData) (struct Painter *, uint32_t *data,
                        int x, int y, int w, int h, int s);
};

#endif /* Y_BUFFER_PAINTERCLASS_H */

/* arch-tag: a885a98d-30d8-47ae-960e-c48837859d1f
 */
