#ifndef Y_UTIL_LIST_H
#define Y_UTIL_LIST_H

struct List;
struct ListIterator;

struct List *listCreate ();

void         listDestroy   (struct List *, void (*destructorFunction)(void *));
int          listCount     (struct List *);
void         listAppend    (struct List *, void *);
void         listPrepend   (struct List *, void *);
void *       listPeekFront (struct List *);
void *       listPeekBack  (struct List *);
void *       listPopFront  (struct List *);
void *       listPopBack   (struct List *);

struct ListIterator *listGetStartIterator (struct List *);
struct ListIterator *listGetEndIterator   (struct List *);

void   listiteratorDestroy  (struct ListIterator *);
int    listiteratorHasValue (struct ListIterator *);
void * listiteratorGet      (struct ListIterator *);
void * listiteratorRemove   (struct ListIterator *);
void   listiteratorNext     (struct ListIterator *);
void   listiteratorPrevious (struct ListIterator *);

struct ListIterator *listiteratorClone (struct ListIterator *);

#endif /* Y_UTIL_LIST_H */

/* arch-tag: 480b37a6-74d7-4777-be5d-4853b230a351
 */
