
#define CHECK_STOP abort()
#include <Y/util/check.h>

#include <Y/util/list.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

char *checkName;
char *checkModule;

#define FUNCTIONALITY_NUM_CHECK 1000

struct list_check_Functionality
{
  int checkCode;
};

int list_check_functionality_destruction[FUNCTIONALITY_NUM_CHECK];

static void
list_check_functionality_destructorFunction (void *obj_v)
{
  struct list_check_Functionality *obj = obj_v;
  list_check_functionality_destruction[obj->checkCode]++; 
  free (obj);
};

static int
list_check_functionality ()
{
  struct List *list;
  struct ListIterator *iter;
  struct list_check_Functionality *objs[FUNCTIONALITY_NUM_CHECK];
  int i;

  checkModule = "functionality";

  list = listCreate ();

  CHECK_THAT ( list != NULL );

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      objs[i] = malloc (sizeof (struct list_check_Functionality));
      objs[i] -> checkCode = i;
      listAppend (list, objs[i]);
    }

  CHECK_THAT (listPeekFront (list) == objs[0]);
  CHECK_THAT (listPeekBack (list) == objs[FUNCTIONALITY_NUM_CHECK-1]);

  iter = listGetStartIterator (list);
  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      CHECK_THAT (listiteratorHasValue (iter));
      CHECK_THAT (listiteratorGet (iter) == objs[i]);
      listiteratorNext (iter);
    }

  CHECK_THAT (listiteratorHasValue (iter) == 0);
  CHECK_THAT (listiteratorGet (iter) == NULL);

  listiteratorDestroy (iter);

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      struct list_check_Functionality *obj = listPopFront (list);
      CHECK_THAT ( obj == objs[i] );
    }

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      listPrepend (list, objs[i]);
    }

  CHECK_THAT (listPeekBack (list) == objs[0]);
  CHECK_THAT (listPeekFront (list) == objs[FUNCTIONALITY_NUM_CHECK-1]);

  iter = listGetEndIterator (list);
  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      CHECK_THAT (listiteratorHasValue (iter));
      CHECK_THAT (listiteratorGet (iter) == objs[i]);
      listiteratorPrevious (iter);
    }

  CHECK_THAT (listiteratorHasValue (iter) == 0);
  CHECK_THAT (listiteratorGet (iter) == NULL);

  listiteratorDestroy (iter);
  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      struct list_check_Functionality *obj = listPopBack (list);
      CHECK_THAT ( obj == objs[i] );
    }

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      listAppend (list, objs[i]);
    }

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      list_check_functionality_destruction[i] = 0;
    }

  listDestroy (list, list_check_functionality_destructorFunction);

  for (i=0; i<FUNCTIONALITY_NUM_CHECK; ++i)
    {
      CHECK_THAT (list_check_functionality_destruction[i] == 1);
    }

  return 0;

}

int
main (int argc, char **argv)
{
  int failed = 0;
  checkName = "List";
  failed = list_check_functionality () ? 1 : failed;
  return failed;
}


/* arch-tag: d65f5494-1dc8-462b-b0cc-d8d391c644aa
 */
