
#define CHECK_STOP abort()
#include <Y/util/check.h>

#include <Y/util/rectangle.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

char *checkName;
char *checkModule;

int
rectangle_check_functionality ()
{
  struct Rectangle *r1, *r2, *r3;

  checkModule = "functionality";

  r1 = rectangleCreate (-400, 0, 800, 200);

  CHECK_THAT ( r1 != NULL );
  CHECK_THAT ( r1->x == -400 );
  CHECK_THAT ( r1->y == 0 );
  CHECK_THAT ( r1->w == 800 );
  CHECK_THAT ( r1->h == 200 );

  r2 = rectangleDuplicate (r1);

  CHECK_THAT ( r2 != NULL );
  CHECK_THAT ( r2->x == -400 );
  CHECK_THAT ( r2->y == 0 );
  CHECK_THAT ( r2->w == 800 );
  CHECK_THAT ( r2->h == 200 );

  r1->x = 0;

  CHECK_THAT ( r1->x == 0 );
  CHECK_THAT ( r2->x == -400 );

  r3 = rectangleCreate (-1, -1, -1, -1);

  CHECK_THAT ( r3 != NULL );

  /* Union two disparate rectangles */
  r1->x = 0;
  r1->y = 0;
  r1->w = 10;
  r1->h = 10;
  r2->x = 20;
  r2->y = 20;
  r2->w = 10;
  r2->h = 10;

  CHECK_THAT ( rectangleUnion (r3, r1, r2) == 0 );
  CHECK_THAT ( r3->x == 0 );
  CHECK_THAT ( r3->y == 0 );
  CHECK_THAT ( r3->w == 30 );
  CHECK_THAT ( r3->h == 30 );

  /* Union two intersecting rectangles */  
  r1->x = 0;
  r1->y = 0;
  r1->w = 30;
  r1->h = 30;
  r2->x = 10;
  r2->y = 10;
  r2->w = 30;
  r2->h = 30;

  CHECK_THAT ( rectangleUnion (r3, r1, r2) == 1 );
  CHECK_THAT ( r3->x == 0 );
  CHECK_THAT ( r3->y == 0 );
  CHECK_THAT ( r3->w == 40 );
  CHECK_THAT ( r3->h == 40 );

  /* Intersect two disparate rectangles */
  r1->x = 0;
  r1->y = 0;
  r1->w = 10;
  r1->h = 10;
  r2->x = 20;
  r2->y = 20;
  r2->w = 10;
  r2->h = 10;

  CHECK_THAT ( rectangleIntersect (r3, r1, r2) == 0 );

  /* Union two intersecting rectangles */  
  r1->x = 0;
  r1->y = 0;
  r1->w = 30;
  r1->h = 30;
  r2->x = 20;
  r2->y = 20;
  r2->w = 30;
  r2->h = 30;

  CHECK_THAT ( rectangleIntersect (r3, r1, r2) == 1 );
  CHECK_THAT ( r3->x == 20 );
  CHECK_THAT ( r3->y == 20 );
  CHECK_THAT ( r3->w == 10 );
  CHECK_THAT ( r3->h == 10 );

  rectangleDestroy (r1);
  rectangleDestroy (r2);
  rectangleDestroy (r3);

  return 0;
}

int
main (int argc, char **argv)
{
  int failed = 0;
  checkName = "Rectangle";
  failed = rectangle_check_functionality () ? 1 : failed;
  return failed;
}

/* arch-tag: 04c58d6c-64f5-4748-a48a-147483660e2f
 */
