#ifndef Y_WIDGET_WINDOW_H
#define Y_WIDGET_WINDOW_H

struct Window;

enum WindowReshapeMode
{
  WINDOW_RESHAPE_NONE,
  WINDOW_RESHAPE_MOVE,
  WINDOW_RESHAPE_RESIZE_NW, WINDOW_RESHAPE_RESIZE_N, WINDOW_RESHAPE_RESIZE_NE,
  WINDOW_RESHAPE_RESIZE_W,                           WINDOW_RESHAPE_RESIZE_E,
  WINDOW_RESHAPE_RESIZE_SW, WINDOW_RESHAPE_RESIZE_S, WINDOW_RESHAPE_RESIZE_SE
};

enum WindowSizeState
{
  WINDOW_SIZE_NORMAL, WINDOW_SIZE_MAXIMISE
};

#include <Y/y.h>
#include <Y/widget/widget.h>
#include <Y/buffer/painter.h>

struct Window * windowCreate    ();
void            windowDestroy   (struct Window *);
struct Widget * windowToWidget  (struct Window *);
struct Object * windowToObject  (struct Window *);

struct Widget * windowGetChild  (struct Window *);

struct Widget * windowGetFocussedWidget  (struct Window *);
void            windowSetFocussedWidget  (struct Window *, struct Widget *);

void            windowStartReshape (struct Window *, int xHandle, int yHandle,
                                    enum WindowReshapeMode mode);
void            windowStopReshape (struct Window *);

void            windowSetSizeState (struct Window *, enum WindowSizeState);
enum WindowSizeState
                windowGetSizeState (struct Window *);

void            windowRequestClose (struct Window *);

void            windowSaveGeometry (struct Window *);
void            windowRestoreGeometry (struct Window *);

#endif /* Y_WIDGET_WINDOW_H */

/* arch-tag: f4f25bca-aa44-4f8e-a586-2c0f0372f91d
 */
