
#include <Y/c++/canvas.h>
#include <Y/c++/y.h>

#include <cstdarg>

#include <sstream>
#include <iostream>

using std::ostringstream;
using std::cout;
using std::endl;

int Y::Canvas::canvasClassId = 0;

Y::Canvas::Canvas ()
{
  if (canvasClassId == 0)
    canvasClassId = Y::Y::findClassId ("Canvas");

  create (canvasClassId);

  subscribeSignal ("resize");
}

Y::Canvas::~Canvas ()
{
}

void
Y::Canvas::onEvent (const string &name, const vector<string> &params)
{
  if (name == "resize")
    {
      resize ();
    }
}

void
Y::Canvas::savePainterState ()
{
}

void
Y::Canvas::restorePainterState ()
{
}

void
Y::Canvas::setBlendMode ()
{
}

void
Y::Canvas::setPenColour (uint32_t colour)
{
  ostringstream ss;
  ss << "setPenColour" << Y::sep << colour;
  invokeMethod (ss.str (), false);
}

void
Y::Canvas::setFillColour (uint32_t colour)
{
  ostringstream ss;
  ss << "setFillColour" << Y::sep << colour;
  invokeMethod (ss.str (), false);
}

void
Y::Canvas::reset (int &newWidth, int &newHeight)
{
  vector<string> res = invokeMethod ("reset");
  if (res.size () >= 2)
    {
      newWidth  = std::strtol (res[0].c_str (), NULL, 0);
      newHeight = std::strtol (res[1].c_str (), NULL, 0);
    }
}

void
Y::Canvas::clearRectangle (int x, int y, int w, int h)
{
}

void
Y::Canvas::drawRectangle (int x, int y, int w, int h)
{
}

void
Y::Canvas::drawHLine (int x, int y, int dx)
{
}

void
Y::Canvas::drawVLine (int x, int y, int dy)
{
}

void
Y::Canvas::drawLine (int x, int y, int dx, int dy)
{
  ostringstream ss;
  ss << "drawLines" << Y::sep << x  << Y::sep << y <<
                       Y::sep << dx << Y::sep << dy;
  invokeMethod (ss.str (), false);
}

void
Y::Canvas::drawHLines (int n, ...)
{
}

void
Y::Canvas::drawVLines (int n, ...)
{
}

void
Y::Canvas::drawLines (int n, ...)
{
  va_list arg;
  int x, y, dx, dy;
  int i;
  ostringstream ss;

  if (n == 0)
    return;
  va_start (arg, n);
  ss << "drawLines";

  for (i = 0; i < n; ++i)
    {
       x  = va_arg (arg, int);
       y  = va_arg (arg, int);
       dx = va_arg (arg, int);
       dy = va_arg (arg, int);
       ss << Y::sep << x  << Y::sep << y <<
             Y::sep << dx << Y::sep << dy;
    }
  invokeMethod (ss.str (), false);
  va_end (arg);
}

void
Y::Canvas::setBufferSize (int w, int h)
{
  ostringstream ss;
  ss << "setBufferSize" << Y::sep << w << Y::sep << h;
  invokeMethod (ss.str (), false);
}

void
Y::Canvas::swapBuffers ()
{
  invokeMethod ("swapBuffers", false);
}

void
Y::Canvas::requestSize (int w, int h)
{
  ostringstream ss;
  ss << "requestSize" << Y::sep << w
                      << Y::sep << h;
  invokeMethod (ss.str (), false);
}

/* arch-tag: 68c6c4a6-b5a4-40b1-9ba1-fdf272b6e55a
 */
