#ifndef Y_CPP_OBJECT_H
#define Y_CPP_OBJECT_H

#include <unistd.h>

#include <sigc++/signal_system.h>

#include <string>
#include <vector>
#include <map>

using std::string;
using std::vector;
using std::map;

namespace Y
{
  class Object : public SigC::Object
  {
    public:
      virtual ~Object ();

      static Object *find (int id);
      inline int getId () const { return oid; }

      void setProperty (const string &name, const string &value);
      void setProperty (const string &name, int value);
      string getProperty (const string &name);

      void subscribeSignal (const string &name);

      virtual void onEvent (const string &name, const vector<string> &params);

    protected:
      Object ();
      void create (int classId);

      vector<string> invokeMethod (const string &nameAndParams,
                                   bool expectReturn = true);

      void setProperty (const string &nameAndValue);

      int oid;
      int cid;

    private:
      Object (const Object &);
      void operator= (const Object &);

      static map<int, Object *> objects;
  };
}

#endif

/* arch-tag: 5aeb402d-cbd4-4a3d-a5b5-6aa8cd7785b2
 */
