
#include <Y/c++/window.h>
#include <Y/c++/y.h>

#include <sstream>

using std::ostringstream;

int Y::Window::windowClassId = 0;

Y::Window::Window ()
{
  if (windowClassId == 0)
    windowClassId = Y::Y::findClassId ("Window");

  create (windowClassId);

  subscribeSignal ("requestClose");
}

Y::Window::~Window ()
{
}

void
Y::Window::show ()
{
  invokeMethod ("show", false); 
}

void
Y::Window::setChild (Widget *w)
{
  if (w != NULL)
    {
      ostringstream ss;
      ss << "setChild" << Y::sep << w->getId();
      invokeMethod (ss.str(), false);
    }
}

void
Y::Window::setFocussed (Widget *w)
{
  if (w != NULL)
    {
      ostringstream ss;
      ss << "setFocussed" << Y::sep << w->getId();
      invokeMethod (ss.str(), false);
    }
}

void
Y::Window::onEvent (const string &name, const vector<string> &params)
{
  if (name == "requestClose")
    {
      requestClose ();
    }
}

/* arch-tag: 4952e419-7783-4f6c-86cc-cf90f1a077b5
 */
