#ifndef Y_CPP_Y_H
#define Y_CPP_Y_H

#include <Y/c++.h>
#include <Y/libY.h>
#include <sigc++/signal_system.h>

#include <sys/time.h>

#include <vector>
#include <list>
#include <string>
#include <iostream>

using std::string;
using std::list;
using std::vector;

namespace Y
{
  class Y
  {
    public:
      static void initialise (int *argcp, char ***argvp);
      static void finalise ();

      static void run ();

      static SigC::Signal0<void> timer;
      static void time (int msec);

      static int findClassId (const char *className);
      static vector<string> parseParams (char *data, int len);
      static void processEvent (struct Message *);

      static const char sep = '\x1c';

      static void sendMessage (struct Message *);
      static void recvMessage (struct Message *);

    private:
      bool timeout;
      struct timeval timeoutAt;
      list<struct Message *> events;

      static Y *instance;

      Y (int *argcp, char ***argvp);
      virtual ~Y ();
  };
}

#endif

/* arch-tag: 72c79697-f1f5-415d-aa8b-346cdbd07511
 */
