
#include <Y/modules/module_interface.h>
#include <Y/modules/theme_interface.h>

#include <Y/util/yutil.h>
#include <Y/text/font.h>

#include "window.h"
#include "draw.h"

static struct Font *basicDefaultFont;

static struct Font *
basicGetDefaultFont ()
{
   return basicDefaultFont;
}

static struct Theme basicTheme =
{
  name:           "Basic Theme",

  drawBackgroundPane:  basicDrawBackgroundPane,
  drawButtonPane:      basicDrawButtonPane,
  getDefaultFont:      basicGetDefaultFont,

  windowInit:          basicWindowInit,
  windowPaint:         basicWindowPaint,
  windowGetRegion:     basicWindowGetRegion,
  windowPointerMotion: basicWindowPointerMotion,
  windowPointerButton: basicWindowPointerButton,
  windowReconfigure:   basicWindowReconfigure,
  windowResize:        basicWindowResize

};

int
initialise (struct Module *module, int argc, const char **argv)
{
  module -> name = "Basic Theme";
  module -> data = &basicTheme;

  basicDefaultFont = fontCreate ("Verdana", "Regular", 12);

  themeAdd (&basicTheme);
  return 0;
}

int
finalise (struct Module *module)
{
  fontDestroy (basicDefaultFont);
  themeRemove (&basicTheme);
  return 0;
}

/* arch-tag: 7eddb9ed-9c2f-4dbe-b45c-eb9db7cca2fd
 */
